#include <nemo/stdint.h>
#include <nemo/unixtypes.h>

#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/djbiofd.h>
#include <nemo/getln.h>
#include <nemo/exit.h>
#include <nemo/tai.h>
#include <nemo/caldate.h>
#include <nemo/caltime.h>
#include <nemo/leapsecs.h>
#include <nemo/error.h>

#include "mess822.h"
#include "die.h"

const char USAGE[] = "name";

static mess822_addrlist addr_list = MESS822_ADDRLIST;

static mess822_action a[] = {
/*  name    f  c  v  address     w  */
  { "from", 0, 0, 0, &addr_list, 0 },
  { 0,      0, 0, 0, 0,          0 }
};

static stralloc line = STRALLOC;

int main(int argc, char **argv)
{
  unsigned int i;
  unsigned int count;
  mess822_addrdata *addr_data;

  PROGRAM = argv[0];
  if (argc > 2) die_usage();
  if (argc == 2) {
    a[0].name = argv[1];
  }

  if (!mess822_slurp_headers(djbiofd_insmall, &line, a)) {
    if (errno == error_proto) die_proto();
    if (errno == error_nomem) die_nomem();
    die_read("input");
  }

  for (count = i = 0; i < addr_list.len; i++) {
    addr_data = &addr_list.ad[i];
    if (addr_data->type != '@') continue;
    djbio_putsa(djbiofd_outsmall, &addr_data->data);
    djbio_puteol(djbiofd_outsmall);
    djbio_flush(djbiofd_outsmall);
    count++;
  }
  _exit((count) ? 100 : 0);
}
