#include <nemo/stdint.h>
#include <nemo/unixtypes.h>

#include <nemo/stralloc.h>
#include <nemo/djbio.h>
#include <nemo/djbiofd.h>
#include <nemo/exit.h>
#include <nemo/tai.h>
#include <nemo/caldate.h>
#include <nemo/caltime.h>
#include <nemo/leapsecs.h>
#include <nemo/error.h>

#include "mess822.h"
#include "die.h"

const char USAGE[] = "name";

static mess822_time t;
static struct tai sec;

static mess822_action a[] = {
/*  name    f  c  v  a  when  */
  { "date", 0, 0, 0, 0, &t },
  { 0,      0, 0, 0, 0, 0 }
};

static stralloc line = STRALLOC;
static char fmtbuf[FMT_CALTIME];

int main(int argc, char **argv)
{
  PROGRAM = argv[0];
  if (argc > 2) die_usage();
  if (argc == 2) {
    a[0].name = argv[1];
  }

  if (leapsecs_init() < 0) die_leapsecs();

  if (!mess822_slurp_headers(djbiofd_insmall, &line, a)) {
    if (errno == error_proto) die_proto();
    if (errno == error_nomem) die_nomem();
    die_read("input");
  }
  if (!t.known) _exit(100);

  djbio_put(djbiofd_outsmall, fmtbuf, caltime_fmt(&t.ct, fmtbuf));
  djbio_puteol(djbiofd_outsmall);
  caltime_tai(&t.ct, &sec);
  caltime_utc(&t.ct, &sec, (int*)0, (int*)0);
  djbio_put(djbiofd_outsmall, fmtbuf, caltime_fmt(&t.ct, fmtbuf));
  djbio_puteol(djbiofd_outsmall);
  caltime_local(&t.ct, &sec, (int*)0, (int*)0);
  djbio_put(djbiofd_outsmall, fmtbuf, caltime_fmt_ctime(&t.ct, fmtbuf));
  djbio_puteol(djbiofd_outsmall);
  djbio_flush(djbiofd_outsmall);
  _exit(0);
}
