#include <nemo/stdint.h>
#include <nemo/stralloc.h>
#include <nemo/sa_vector.h>
#include <nemo/constmap.h>

#include "mess822.h"

static const sa_vector *list_excludes = 0;
static struct constmap map_excludes = CONSTMAP;

static unsigned int exclude(const stralloc *value)
{
  return constmap(&map_excludes, value->s, value->len) != 0;
}

void mess822_header_excludes(mess822_header *h, const sa_vector *list)
{
  h->exclude = exclude;
  list_excludes = list;
  constmap_init(&map_excludes, list_excludes, 0);
}
