#include <nemo/stdint.h>
#include <nemo/unixtypes.h>
#include <nemo/tai.h>
#include <nemo/taia.h>
#include <nemo/unix.h>

#include "mess822.h"

static unsigned int append_value(stralloc *out, unsigned long value)

{
  if (!stralloc_append(out, "-")) return 0;
  if (!stralloc_catxlong(out, value)) return 0;
  return 1;
}

unsigned int mess822_mime_delimiter(stralloc *out, const char *prefix)
{
  struct taia now;
  time_t seconds;

  taia_now(&now);
  seconds = taia_epoch(&now);

  if (!stralloc_copyb(out, "=_=", 3)) return 0;
  if (!stralloc_cats(out, prefix)) return 0;
  if (!append_value(out, (unsigned long)seconds)) return 0;
  if (!append_value(out, now.nano)) return 0;
  if (!append_value(out, (long unsigned int)getpid())) return 0;
  if (!append_value(out, (long unsigned int)unix_cryptorandomnumber())) return 0;
  if (!stralloc_catb(out, "=_=", 3)) return 0;

  return 1;
}
