#include <nemo/byte.h>

#include "mess822.h"

unsigned int mess822_ok(const stralloc *line)
{
  unsigned int i;
  unsigned int len;
  unsigned int colon;

  len = line->len;
  if (!len) return 0;
  if (line->s[len - 1] == '\n') {
    --len;
  }
  if (!len) return 0;

  /* if input message is 822-compliant, will return 1 after this */

  if (line->s[0] == ' ') return 1;
  if (line->s[0] == '\t') return 1;

  colon = byte_chr(line->s, len, ':');
  if (colon == len) return 0;

  while (colon && ((line->s[colon - 1] == ' ') || (line->s[colon - 1] == '\t'))) {
    --colon;
  }
  if (!colon) return 0;

  for (i = 0; i < colon; ++i) {
    if (line->s[i] < 33) return 0;
    if (line->s[i] > 126) return 0;
  }

  return 1;
}
