#include "mess822.h"

unsigned int mess822_quoteplus(stralloc *out, const stralloc *addr, const stralloc *comment)
{
  static stralloc tmp = STRALLOC;
  unsigned int i;
  unsigned int flag_empty;
  unsigned int flag_bracket;
  const char *quote;

  flag_empty = 0;
  if (!addr->len) {
    flag_empty = 1;
  }
  if (stralloc_equals(addr, "@")) {
    flag_empty = 1;
  }

  flag_bracket = flag_empty;

  if (comment->len) {
    if (!mess822_encode_data(out, comment->s, comment->len, "\"", "\" ")) return 0;
    flag_bracket = 1;
  }

  if (flag_bracket) {
    if (!stralloc_cats(out, "<")) return 0;
  }

  if (!flag_empty) {
    i = stralloc_rchr(addr, '@');
    quote = mess822_need_quote(addr, i) ? "\"" : "";
    if (!mess822_encode_data(out, addr->s, i, quote, quote)) return 0;

    if (addr->s[i] == '@') ++i;
    if (!stralloc_copyb(&tmp, addr->s + i, addr->len - i)) return 0;

    i = stralloc_len(&tmp);
    if (i) {
      if (!stralloc_append(out, "@")) return 0;

      quote = mess822_need_quote(&tmp, i) ? "\"" : "";

      if (*quote && (i >= 2) && (tmp.s[0] == '[') && (tmp.s[i - 1] == ']')) {
        if (!mess822_encode_data(out, tmp.s + 1, i - 2, "[", "]")) return 0;
      }
      else {
        if (!mess822_encode_data(out, tmp.s, i, quote, quote)) return 0;
      }
    }
  }

  if (flag_bracket) {
    if (!stralloc_cats(out, ">")) return 0;
  }

  return 1;
}
